using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;

using TAPI;
using Terraria;

namespace FearTheReaper.Buffs {
    public class AnchoredBuff : TAPI.ModBuff {
		public override void Effects( Player player, int index ) {
			FTR_Player ftr_player = player.GetSubClass<FTR_Player>();

			int this_type = BuffDef.byName["FearTheReaper:AnchoredBuff"];
			bool is_same_type = player.buffType[index] == this_type;
			bool is_running = player.buffTime[index] > 0;
			bool player_valid = player.active && !player.dead;

			// Note to devs: Type checking seems to be necessary!
			if( is_same_type && is_running && player_valid ) {
				ftr_player.IsAnchored = true;
			} else {
				ftr_player.IsAnchored = false;
			}

			if( ftr_player.IsAnchored ) {
				// Disable flight
				player.wingTime = 0f;
			}
		}


		//public override void MidUpdate( Player player ) {
		//    FTR_Player ftr_player = player.GetSubClass<FTR_Player>();

		//    if( !HasEffect ) {
		//        if( ftr_player.IsAnchored ) {
		//            ftr_player.IsAnchored = false;
		//        }
		//        return;
		//    }

		//    ftr_player.IsAnchored = true;

		//    // Always disable flight
		//    ftr_player.player.wingTime = 0f;
		//}

		public override void Start( Player player, int index ) {
			FTR_Player ftr_player = player.GetSubClass<FTR_Player>();
			ftr_player.IsAnchored = true;
		}

		public override void End( Player player, int index ) {
			FTR_Player ftr_player = player.GetSubClass<FTR_Player>();
			ftr_player.IsAnchored = false;
		}
    }
}
